# coding: utf-8

"""
    openapi 3.0.3 sample spec

    sample spec for testing openapi functionality, built from json schema tests for draft6  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Generated by: https://openapi-generator.tech
"""

import unittest

import unit_test_api
from unit_test_api.model.maximum_validation import MaximumValidation
from unit_test_api import configuration


class TestMaximumValidation(unittest.TestCase):
    """MaximumValidation unit test stubs"""
    _configuration = configuration.Configuration()

    def test_below_the_maximum_is_valid_passes(self):
        # below the maximum is valid
        MaximumValidation.from_openapi_data_oapg(
            2.6,
            _configuration=self._configuration
        )

    def test_boundary_point_is_valid_passes(self):
        # boundary point is valid
        MaximumValidation.from_openapi_data_oapg(
            3.0,
            _configuration=self._configuration
        )

    def test_above_the_maximum_is_invalid_fails(self):
        # above the maximum is invalid
        with self.assertRaises((unit_test_api.ApiValueError, unit_test_api.ApiTypeError)):
            MaximumValidation.from_openapi_data_oapg(
                3.5,
                _configuration=self._configuration
            )

    def test_ignores_non_numbers_passes(self):
        # ignores non-numbers
        MaximumValidation.from_openapi_data_oapg(
            "x",
            _configuration=self._configuration
        )


if __name__ == '__main__':
    unittest.main()
