# coding: utf-8

"""
    openapi 3.0.3 sample spec

    sample spec for testing openapi functionality, built from json schema tests for draft6  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Generated by: https://openapi-generator.tech
"""

import unittest

import unit_test_api
from unit_test_api.model.maxproperties_validation import MaxpropertiesValidation
from unit_test_api import configuration


class TestMaxpropertiesValidation(unittest.TestCase):
    """MaxpropertiesValidation unit test stubs"""
    _configuration = configuration.Configuration()

    def test_too_long_is_invalid_fails(self):
        # too long is invalid
        with self.assertRaises((unit_test_api.ApiValueError, unit_test_api.ApiTypeError)):
            MaxpropertiesValidation.from_openapi_data_oapg(
                {
                    "foo":
                        1,
                    "bar":
                        2,
                    "baz":
                        3,
                },
                _configuration=self._configuration
            )

    def test_ignores_arrays_passes(self):
        # ignores arrays
        MaxpropertiesValidation.from_openapi_data_oapg(
            [
                1,
                2,
                3,
            ],
            _configuration=self._configuration
        )

    def test_ignores_other_non_objects_passes(self):
        # ignores other non-objects
        MaxpropertiesValidation.from_openapi_data_oapg(
            12,
            _configuration=self._configuration
        )

    def test_ignores_strings_passes(self):
        # ignores strings
        MaxpropertiesValidation.from_openapi_data_oapg(
            "foobar",
            _configuration=self._configuration
        )

    def test_shorter_is_valid_passes(self):
        # shorter is valid
        MaxpropertiesValidation.from_openapi_data_oapg(
            {
                "foo":
                    1,
            },
            _configuration=self._configuration
        )

    def test_exact_length_is_valid_passes(self):
        # exact length is valid
        MaxpropertiesValidation.from_openapi_data_oapg(
            {
                "foo":
                    1,
                "bar":
                    2,
            },
            _configuration=self._configuration
        )


if __name__ == '__main__':
    unittest.main()
