# coding: utf-8

"""
    openapi 3.0.3 sample spec

    sample spec for testing openapi functionality, built from json schema tests for draft6  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Generated by: https://openapi-generator.tech
"""

import unittest

import unit_test_api
from unit_test_api.model.pattern_validation import PatternValidation
from unit_test_api import configuration


class TestPatternValidation(unittest.TestCase):
    """PatternValidation unit test stubs"""
    _configuration = configuration.Configuration()

    def test_ignores_arrays_passes(self):
        # ignores arrays
        PatternValidation.from_openapi_data_oapg(
            [
            ],
            _configuration=self._configuration
        )

    def test_ignores_objects_passes(self):
        # ignores objects
        PatternValidation.from_openapi_data_oapg(
            {
            },
            _configuration=self._configuration
        )

    def test_ignores_null_passes(self):
        # ignores null
        PatternValidation.from_openapi_data_oapg(
            None,
            _configuration=self._configuration
        )

    def test_ignores_floats_passes(self):
        # ignores floats
        PatternValidation.from_openapi_data_oapg(
            1.0,
            _configuration=self._configuration
        )

    def test_a_non_matching_pattern_is_invalid_fails(self):
        # a non-matching pattern is invalid
        with self.assertRaises((unit_test_api.ApiValueError, unit_test_api.ApiTypeError)):
            PatternValidation.from_openapi_data_oapg(
                "abc",
                _configuration=self._configuration
            )

    def test_ignores_booleans_passes(self):
        # ignores booleans
        PatternValidation.from_openapi_data_oapg(
            True,
            _configuration=self._configuration
        )

    def test_a_matching_pattern_is_valid_passes(self):
        # a matching pattern is valid
        PatternValidation.from_openapi_data_oapg(
            "aaa",
            _configuration=self._configuration
        )

    def test_ignores_integers_passes(self):
        # ignores integers
        PatternValidation.from_openapi_data_oapg(
            123,
            _configuration=self._configuration
        )


if __name__ == '__main__':
    unittest.main()
