# petstore-api
This spec is mainly for testing Petstore server and contains fake endpoints, models. Please do not use this for any other purpose. Special characters: \" \\

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python &gt;&#x3D;3.7

## Migration from other generators like python and python-legacy

### Changes
1. This generator uses spec case for all (object) property names and parameter names.
    - So if the spec has a property name like camelCase, it will use camelCase rather than camel_case
    - So you will need to update how you input and read properties to use spec case
2. Endpoint parameters are stored in dictionaries to prevent collisions (explanation below)
    - So you will need to update how you pass data in to endpoints
3. Endpoint responses now include the original response, the deserialized response body, and (todo)the deserialized headers
    - So you will need to update your code to use response.body to access deserialized data
4. All validated data is instantiated in an instance that subclasses all validated Schema classes and Decimal/str/list/tuple/frozendict/NoneClass/BoolClass/bytes/io.FileIO
    - This means that you can use isinstance to check if a payload validated against a schema class
    - This means that no data will be of type None/True/False
        - ingested None will subclass NoneClass
        - ingested True will subclass BoolClass
        - ingested False will subclass BoolClass
        - So if you need to check is True/False/None, instead use instance.is_true_oapg()/.is_false_oapg()/.is_none_oapg()
5. All validated class instances are immutable except for ones based on io.File
    - This is because if properties were changed after validation, that validation would no longer apply
    - So no changing values or property values after a class has been instantiated
6. String + Number types with formats
    - String type data is stored as a string and if you need to access types based on its format like date,
    date-time, uuid, number etc then you will need to use accessor functions on the instance
    - type string + format: See .as_date_oapg, .as_datetime_oapg, .as_decimal_oapg, .as_uuid_oapg
    - type number + format: See .as_float_oapg, .as_int_oapg
    - this was done because openapi/json-schema defines constraints. string data may be type string with no format
    keyword in one schema, and include a format constraint in another schema
    - So if you need to access a string format based type, use as_date_oapg/as_datetime_oapg/as_decimal_oapg/as_uuid_oapg
    - So if you need to access a number format based type, use as_int_oapg/as_float_oapg
7. Property access on AnyType(type unset) or object(dict) schemas
    - Only required keys with valid python names are properties like .someProp and have type hints
    - All optional keys may not exist, so properties are not defined for them
    - One can access optional values with dict_instance['optionalProp'] and KeyError will be raised if it does not exist
    - Use get_item_oapg if you need a way to always get a value whether or not the key exists
        - If the key does not exist, schemas.unset is returned from calling dict_instance.get_item_oapg('optionalProp')
        - All required and optional keys have type hints for this method, and @typing.overload is used
        - A type hint is also generated for additionalProperties accessed using this method
    - So you will need to update you code to use some_instance['optionalProp'] to access optional property
    and additionalProperty values
8. The location of the api classes has changed
    - Api classes are located in your_package.apis.tags.some_api
    - This change was made to eliminate redundant code generation
    - Legacy generators generated the same endpoint twice if it had > 1 tag on it
    - This generator defines an endpoint in one class, then inherits that class to generate
      apis by tags and by paths
    - This change reduces code and allows quicker run time if you use the path apis
        - path apis are at your_package.apis.paths.some_path
    - Those apis will only load their needed models, which is less to load than all of the resources needed in a tag api
    - So you will need to update your import paths to the api classes

### Why are Oapg and _oapg used in class and method names?
Classes can have arbitrarily named properties set on them
Endpoints can have arbitrary operationId method names set
For those reasons, I use the prefix Oapg and _oapg to greatly reduce the likelihood of collisions
on protected + public classes/methods.
oapg stands for OpenApi Python Generator.

### Object property spec case
This was done because when payloads are ingested, they can be validated against N number of schemas.
If the input signature used a different property name then that has mutated the payload.
So SchemaA and SchemaB must both see the camelCase spec named variable.
Also it is possible to send in two properties, named camelCase and camel_case in the same payload.
That use case should be support so spec case is used.

### Parameter spec case
Parameters can be included in different locations including:
- query
- path
- header
- cookie

Any of those parameters could use the same parameter names, so if every parameter
was included as an endpoint parameter in a function signature, they would collide.
For that reason, each of those inputs have been separated out into separate typed dictionaries:
- query_params
- path_params
- header_params
- cookie_params

So when updating your code, you will need to pass endpoint parameters in using those
dictionaries.

### Endpoint responses
Endpoint responses have been enriched to now include more information.
Any response reom an endpoint will now include the following properties:
response: urllib3.HTTPResponse
body: typing.Union[Unset, Schema]
headers: typing.Union[Unset, TODO]
Note: response header deserialization has not yet been added


## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import petstore_api
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import petstore_api
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
import datetimeimport datetimeimport datetimeimport datetimeimport datetimeimport datetimeimport datetime
import time
import petstore_api
from pprint import pprint
from petstore_api.apis.tags import another_fake_api
from petstore_api.model.client import Client
# Defining the host is optional and defaults to http://petstore.swagger.io:80/v2
# See configuration.py for a list of all supported configuration parameters.
configuration = petstore_api.Configuration(
    host = "http://petstore.swagger.io:80/v2"
)


# Enter a context with an instance of the API client
with petstore_api.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = another_fake_api.AnotherFakeApi(api_client)
    client = Client(
        client="client_example",
    ) # Client | client model

    try:
        # To test special tags
        api_response = api_instance.call_123_test_special_tags(client)
        pprint(api_response)
    except petstore_api.ApiException as e:
        print("Exception when calling AnotherFakeApi->call_123_test_special_tags: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *http://petstore.swagger.io:80/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AnotherFakeApi* | [**call_123_test_special_tags**](docs/apis/tags/AnotherFakeApi.md#call_123_test_special_tags) | **patch** /another-fake/dummy | To test special tags
*DefaultApi* | [**foo_get**](docs/apis/tags/DefaultApi.md#foo_get) | **get** /foo | 
*FakeApi* | [**additional_properties_with_array_of_enums**](docs/apis/tags/FakeApi.md#additional_properties_with_array_of_enums) | **get** /fake/additional-properties-with-array-of-enums | Additional Properties with Array of Enums
*FakeApi* | [**array_model**](docs/apis/tags/FakeApi.md#array_model) | **post** /fake/refs/arraymodel | 
*FakeApi* | [**array_of_enums**](docs/apis/tags/FakeApi.md#array_of_enums) | **post** /fake/refs/array-of-enums | Array of Enums
*FakeApi* | [**body_with_file_schema**](docs/apis/tags/FakeApi.md#body_with_file_schema) | **put** /fake/body-with-file-schema | 
*FakeApi* | [**body_with_query_params**](docs/apis/tags/FakeApi.md#body_with_query_params) | **put** /fake/body-with-query-params | 
*FakeApi* | [**boolean**](docs/apis/tags/FakeApi.md#boolean) | **post** /fake/refs/boolean | 
*FakeApi* | [**case_sensitive_params**](docs/apis/tags/FakeApi.md#case_sensitive_params) | **put** /fake/case-sensitive-params | 
*FakeApi* | [**client_model**](docs/apis/tags/FakeApi.md#client_model) | **patch** /fake | To test \&quot;client\&quot; model
*FakeApi* | [**composed_one_of_different_types**](docs/apis/tags/FakeApi.md#composed_one_of_different_types) | **post** /fake/refs/composed_one_of_number_with_validations | 
*FakeApi* | [**delete_coffee**](docs/apis/tags/FakeApi.md#delete_coffee) | **delete** /fake/deleteCoffee/{id} | Delete coffee
*FakeApi* | [**endpoint_parameters**](docs/apis/tags/FakeApi.md#endpoint_parameters) | **post** /fake | Fake endpoint for testing various parameters 假端點 偽のエンドポイント 가짜 엔드 포인트 
*FakeApi* | [**enum_parameters**](docs/apis/tags/FakeApi.md#enum_parameters) | **get** /fake | To test enum parameters
*FakeApi* | [**fake_health_get**](docs/apis/tags/FakeApi.md#fake_health_get) | **get** /fake/health | Health check endpoint
*FakeApi* | [**group_parameters**](docs/apis/tags/FakeApi.md#group_parameters) | **delete** /fake | Fake endpoint to test group parameters (optional)
*FakeApi* | [**inline_additional_properties**](docs/apis/tags/FakeApi.md#inline_additional_properties) | **post** /fake/inline-additionalProperties | test inline additionalProperties
*FakeApi* | [**inline_composition**](docs/apis/tags/FakeApi.md#inline_composition) | **post** /fake/inlineComposition/ | testing composed schemas at inline locations
*FakeApi* | [**json_form_data**](docs/apis/tags/FakeApi.md#json_form_data) | **get** /fake/jsonFormData | test json serialization of form data
*FakeApi* | [**json_patch**](docs/apis/tags/FakeApi.md#json_patch) | **patch** /fake/jsonPatch | json patch
*FakeApi* | [**json_with_charset**](docs/apis/tags/FakeApi.md#json_with_charset) | **post** /fake/jsonWithCharset | json with charset tx and rx
*FakeApi* | [**mammal**](docs/apis/tags/FakeApi.md#mammal) | **post** /fake/refs/mammal | 
*FakeApi* | [**number_with_validations**](docs/apis/tags/FakeApi.md#number_with_validations) | **post** /fake/refs/number | 
*FakeApi* | [**object_in_query**](docs/apis/tags/FakeApi.md#object_in_query) | **get** /fake/objInQuery | user list
*FakeApi* | [**object_model_with_ref_props**](docs/apis/tags/FakeApi.md#object_model_with_ref_props) | **post** /fake/refs/object_model_with_ref_props | 
*FakeApi* | [**parameter_collisions**](docs/apis/tags/FakeApi.md#parameter_collisions) | **post** /fake/parameterCollisions/{1}/{aB}/{Ab}/{self}/{A-B}/ | parameter collision case
*FakeApi* | [**query_param_with_json_content_type**](docs/apis/tags/FakeApi.md#query_param_with_json_content_type) | **get** /fake/queryParamWithJsonContentType | query param with json content-type
*FakeApi* | [**query_parameter_collection_format**](docs/apis/tags/FakeApi.md#query_parameter_collection_format) | **put** /fake/test-query-parameters | 
*FakeApi* | [**ref_object_in_query**](docs/apis/tags/FakeApi.md#ref_object_in_query) | **get** /fake/refObjInQuery | user list
*FakeApi* | [**response_without_schema**](docs/apis/tags/FakeApi.md#response_without_schema) | **get** /fake/responseWithoutSchema | receives a response without schema
*FakeApi* | [**string**](docs/apis/tags/FakeApi.md#string) | **post** /fake/refs/string | 
*FakeApi* | [**string_enum**](docs/apis/tags/FakeApi.md#string_enum) | **post** /fake/refs/enum | 
*FakeApi* | [**upload_download_file**](docs/apis/tags/FakeApi.md#upload_download_file) | **post** /fake/uploadDownloadFile | uploads a file and downloads a file using application/octet-stream
*FakeApi* | [**upload_file**](docs/apis/tags/FakeApi.md#upload_file) | **post** /fake/uploadFile | uploads a file using multipart/form-data
*FakeApi* | [**upload_files**](docs/apis/tags/FakeApi.md#upload_files) | **post** /fake/uploadFiles | uploads files using multipart/form-data
*FakeClassnameTags123Api* | [**classname**](docs/apis/tags/FakeClassnameTags123Api.md#classname) | **patch** /fake_classname_test | To test class name in snake case
*PetApi* | [**add_pet**](docs/apis/tags/PetApi.md#add_pet) | **post** /pet | Add a new pet to the store
*PetApi* | [**delete_pet**](docs/apis/tags/PetApi.md#delete_pet) | **delete** /pet/{petId} | Deletes a pet
*PetApi* | [**find_pets_by_status**](docs/apis/tags/PetApi.md#find_pets_by_status) | **get** /pet/findByStatus | Finds Pets by status
*PetApi* | [**find_pets_by_tags**](docs/apis/tags/PetApi.md#find_pets_by_tags) | **get** /pet/findByTags | Finds Pets by tags
*PetApi* | [**get_pet_by_id**](docs/apis/tags/PetApi.md#get_pet_by_id) | **get** /pet/{petId} | Find pet by ID
*PetApi* | [**update_pet**](docs/apis/tags/PetApi.md#update_pet) | **put** /pet | Update an existing pet
*PetApi* | [**update_pet_with_form**](docs/apis/tags/PetApi.md#update_pet_with_form) | **post** /pet/{petId} | Updates a pet in the store with form data
*PetApi* | [**upload_file_with_required_file**](docs/apis/tags/PetApi.md#upload_file_with_required_file) | **post** /fake/{petId}/uploadImageWithRequiredFile | uploads an image (required)
*PetApi* | [**upload_image**](docs/apis/tags/PetApi.md#upload_image) | **post** /pet/{petId}/uploadImage | uploads an image
*StoreApi* | [**delete_order**](docs/apis/tags/StoreApi.md#delete_order) | **delete** /store/order/{order_id} | Delete purchase order by ID
*StoreApi* | [**get_inventory**](docs/apis/tags/StoreApi.md#get_inventory) | **get** /store/inventory | Returns pet inventories by status
*StoreApi* | [**get_order_by_id**](docs/apis/tags/StoreApi.md#get_order_by_id) | **get** /store/order/{order_id} | Find purchase order by ID
*StoreApi* | [**place_order**](docs/apis/tags/StoreApi.md#place_order) | **post** /store/order | Place an order for a pet
*UserApi* | [**create_user**](docs/apis/tags/UserApi.md#create_user) | **post** /user | Create user
*UserApi* | [**create_users_with_array_input**](docs/apis/tags/UserApi.md#create_users_with_array_input) | **post** /user/createWithArray | Creates list of users with given input array
*UserApi* | [**create_users_with_list_input**](docs/apis/tags/UserApi.md#create_users_with_list_input) | **post** /user/createWithList | Creates list of users with given input array
*UserApi* | [**delete_user**](docs/apis/tags/UserApi.md#delete_user) | **delete** /user/{username} | Delete user
*UserApi* | [**get_user_by_name**](docs/apis/tags/UserApi.md#get_user_by_name) | **get** /user/{username} | Get user by user name
*UserApi* | [**login_user**](docs/apis/tags/UserApi.md#login_user) | **get** /user/login | Logs user into the system
*UserApi* | [**logout_user**](docs/apis/tags/UserApi.md#logout_user) | **get** /user/logout | Logs out current logged in user session
*UserApi* | [**update_user**](docs/apis/tags/UserApi.md#update_user) | **put** /user/{username} | Updated user

## Documentation For Models

 - [AdditionalPropertiesClass](docs/models/AdditionalPropertiesClass.md)
 - [AdditionalPropertiesValidator](docs/models/AdditionalPropertiesValidator.md)
 - [AdditionalPropertiesWithArrayOfEnums](docs/models/AdditionalPropertiesWithArrayOfEnums.md)
 - [Address](docs/models/Address.md)
 - [Animal](docs/models/Animal.md)
 - [AnimalFarm](docs/models/AnimalFarm.md)
 - [AnyTypeAndFormat](docs/models/AnyTypeAndFormat.md)
 - [AnyTypeNotString](docs/models/AnyTypeNotString.md)
 - [ApiResponse](docs/models/ApiResponse.md)
 - [Apple](docs/models/Apple.md)
 - [AppleReq](docs/models/AppleReq.md)
 - [ArrayHoldingAnyType](docs/models/ArrayHoldingAnyType.md)
 - [ArrayOfArrayOfNumberOnly](docs/models/ArrayOfArrayOfNumberOnly.md)
 - [ArrayOfEnums](docs/models/ArrayOfEnums.md)
 - [ArrayOfNumberOnly](docs/models/ArrayOfNumberOnly.md)
 - [ArrayTest](docs/models/ArrayTest.md)
 - [ArrayWithValidationsInItems](docs/models/ArrayWithValidationsInItems.md)
 - [Banana](docs/models/Banana.md)
 - [BananaReq](docs/models/BananaReq.md)
 - [Bar](docs/models/Bar.md)
 - [BasquePig](docs/models/BasquePig.md)
 - [Boolean](docs/models/Boolean.md)
 - [BooleanEnum](docs/models/BooleanEnum.md)
 - [Capitalization](docs/models/Capitalization.md)
 - [Cat](docs/models/Cat.md)
 - [Category](docs/models/Category.md)
 - [ChildCat](docs/models/ChildCat.md)
 - [ClassModel](docs/models/ClassModel.md)
 - [Client](docs/models/Client.md)
 - [ComplexQuadrilateral](docs/models/ComplexQuadrilateral.md)
 - [ComposedAnyOfDifferentTypesNoValidations](docs/models/ComposedAnyOfDifferentTypesNoValidations.md)
 - [ComposedArray](docs/models/ComposedArray.md)
 - [ComposedBool](docs/models/ComposedBool.md)
 - [ComposedNone](docs/models/ComposedNone.md)
 - [ComposedNumber](docs/models/ComposedNumber.md)
 - [ComposedObject](docs/models/ComposedObject.md)
 - [ComposedOneOfDifferentTypes](docs/models/ComposedOneOfDifferentTypes.md)
 - [ComposedString](docs/models/ComposedString.md)
 - [Currency](docs/models/Currency.md)
 - [DanishPig](docs/models/DanishPig.md)
 - [DateTimeTest](docs/models/DateTimeTest.md)
 - [DateTimeWithValidations](docs/models/DateTimeWithValidations.md)
 - [DateWithValidations](docs/models/DateWithValidations.md)
 - [DecimalPayload](docs/models/DecimalPayload.md)
 - [Dog](docs/models/Dog.md)
 - [Drawing](docs/models/Drawing.md)
 - [EnumArrays](docs/models/EnumArrays.md)
 - [EnumClass](docs/models/EnumClass.md)
 - [EnumTest](docs/models/EnumTest.md)
 - [EquilateralTriangle](docs/models/EquilateralTriangle.md)
 - [File](docs/models/File.md)
 - [FileSchemaTestClass](docs/models/FileSchemaTestClass.md)
 - [Foo](docs/models/Foo.md)
 - [FormatTest](docs/models/FormatTest.md)
 - [FromSchema](docs/models/FromSchema.md)
 - [Fruit](docs/models/Fruit.md)
 - [FruitReq](docs/models/FruitReq.md)
 - [GmFruit](docs/models/GmFruit.md)
 - [GrandparentAnimal](docs/models/GrandparentAnimal.md)
 - [HasOnlyReadOnly](docs/models/HasOnlyReadOnly.md)
 - [HealthCheckResult](docs/models/HealthCheckResult.md)
 - [IntegerEnum](docs/models/IntegerEnum.md)
 - [IntegerEnumBig](docs/models/IntegerEnumBig.md)
 - [IntegerEnumOneValue](docs/models/IntegerEnumOneValue.md)
 - [IntegerEnumWithDefaultValue](docs/models/IntegerEnumWithDefaultValue.md)
 - [IntegerMax10](docs/models/IntegerMax10.md)
 - [IntegerMin15](docs/models/IntegerMin15.md)
 - [IsoscelesTriangle](docs/models/IsoscelesTriangle.md)
 - [JSONPatchRequest](docs/models/JSONPatchRequest.md)
 - [JSONPatchRequestAddReplaceTest](docs/models/JSONPatchRequestAddReplaceTest.md)
 - [JSONPatchRequestMoveCopy](docs/models/JSONPatchRequestMoveCopy.md)
 - [JSONPatchRequestRemove](docs/models/JSONPatchRequestRemove.md)
 - [Mammal](docs/models/Mammal.md)
 - [MapTest](docs/models/MapTest.md)
 - [MixedPropertiesAndAdditionalPropertiesClass](docs/models/MixedPropertiesAndAdditionalPropertiesClass.md)
 - [Model200Response](docs/models/Model200Response.md)
 - [ModelReturn](docs/models/ModelReturn.md)
 - [Money](docs/models/Money.md)
 - [Name](docs/models/Name.md)
 - [NoAdditionalProperties](docs/models/NoAdditionalProperties.md)
 - [NullableClass](docs/models/NullableClass.md)
 - [NullableShape](docs/models/NullableShape.md)
 - [NullableString](docs/models/NullableString.md)
 - [Number](docs/models/Number.md)
 - [NumberOnly](docs/models/NumberOnly.md)
 - [NumberWithValidations](docs/models/NumberWithValidations.md)
 - [ObjectInterface](docs/models/ObjectInterface.md)
 - [ObjectModelWithArgAndArgsProperties](docs/models/ObjectModelWithArgAndArgsProperties.md)
 - [ObjectModelWithRefProps](docs/models/ObjectModelWithRefProps.md)
 - [ObjectWithAllOfWithReqTestPropFromUnsetAddProp](docs/models/ObjectWithAllOfWithReqTestPropFromUnsetAddProp.md)
 - [ObjectWithDecimalProperties](docs/models/ObjectWithDecimalProperties.md)
 - [ObjectWithDifficultlyNamedProps](docs/models/ObjectWithDifficultlyNamedProps.md)
 - [ObjectWithInlineCompositionProperty](docs/models/ObjectWithInlineCompositionProperty.md)
 - [ObjectWithInvalidNamedRefedProperties](docs/models/ObjectWithInvalidNamedRefedProperties.md)
 - [ObjectWithOptionalTestProp](docs/models/ObjectWithOptionalTestProp.md)
 - [ObjectWithValidations](docs/models/ObjectWithValidations.md)
 - [Order](docs/models/Order.md)
 - [ParentPet](docs/models/ParentPet.md)
 - [Pet](docs/models/Pet.md)
 - [Pig](docs/models/Pig.md)
 - [Player](docs/models/Player.md)
 - [Quadrilateral](docs/models/Quadrilateral.md)
 - [QuadrilateralInterface](docs/models/QuadrilateralInterface.md)
 - [ReadOnlyFirst](docs/models/ReadOnlyFirst.md)
 - [ScaleneTriangle](docs/models/ScaleneTriangle.md)
 - [Shape](docs/models/Shape.md)
 - [ShapeOrNull](docs/models/ShapeOrNull.md)
 - [SimpleQuadrilateral](docs/models/SimpleQuadrilateral.md)
 - [SomeObject](docs/models/SomeObject.md)
 - [SpecialModelName](docs/models/SpecialModelName.md)
 - [String](docs/models/String.md)
 - [StringBooleanMap](docs/models/StringBooleanMap.md)
 - [StringEnum](docs/models/StringEnum.md)
 - [StringEnumWithDefaultValue](docs/models/StringEnumWithDefaultValue.md)
 - [StringWithValidation](docs/models/StringWithValidation.md)
 - [Tag](docs/models/Tag.md)
 - [Triangle](docs/models/Triangle.md)
 - [TriangleInterface](docs/models/TriangleInterface.md)
 - [UUIDString](docs/models/UUIDString.md)
 - [User](docs/models/User.md)
 - [Whale](docs/models/Whale.md)
 - [Zebra](docs/models/Zebra.md)

## Documentation For Authorization


## api_key

- **Type**: API key
- **API key parameter name**: api_key
- **Location**: HTTP header


## api_key_query

- **Type**: API key
- **API key parameter name**: api_key_query
- **Location**: URL query string


## bearer_test

- **Type**: Bearer authentication (JWT)


## http_basic_test

- **Type**: HTTP basic authentication


## http_signature_test

- **Type**: HTTP signature authentication

 Authentication schemes defined for the API:
## petstore_auth

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: http://petstore.swagger.io/api/oauth/dialog
- **Scopes**: 
 - **write:pets**: modify pets in your account
 - **read:pets**: read your pets


## Author









## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in petstore_api.apis and petstore_api.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from petstore_api.apis.default_api import DefaultApi`
- `from petstore_api.model.pet import Pet`

Solution 1:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import petstore_api
from petstore_api.apis import *
from petstore_api.models import *
```
