# do not import all endpoints into this module because that uses a lot of memory and stack frames
# if you need the ability to import all endpoints from this module, import them with
# from petstore_api.apis.path_to_api import path_to_api

import enum


class PathValues(str, enum.Enum):
    FOO = "/foo"
    PET = "/pet"
    PET_FIND_BY_STATUS = "/pet/findByStatus"
    PET_FIND_BY_TAGS = "/pet/findByTags"
    PET_PET_ID = "/pet/{petId}"
    PET_PET_ID_UPLOAD_IMAGE = "/pet/{petId}/uploadImage"
    STORE_INVENTORY = "/store/inventory"
    STORE_ORDER = "/store/order"
    STORE_ORDER_ORDER_ID = "/store/order/{order_id}"
    USER = "/user"
    USER_CREATE_WITH_ARRAY = "/user/createWithArray"
    USER_CREATE_WITH_LIST = "/user/createWithList"
    USER_LOGIN = "/user/login"
    USER_LOGOUT = "/user/logout"
    USER_USERNAME = "/user/{username}"
    FAKE_CLASSNAME_TEST = "/fake_classname_test"
    FAKE = "/fake"
    FAKE_REFS_NUMBER = "/fake/refs/number"
    FAKE_REFS_MAMMAL = "/fake/refs/mammal"
    FAKE_REFS_STRING = "/fake/refs/string"
    FAKE_REFS_BOOLEAN = "/fake/refs/boolean"
    FAKE_REFS_ARRAYMODEL = "/fake/refs/arraymodel"
    FAKE_REFS_COMPOSED_ONE_OF_NUMBER_WITH_VALIDATIONS = "/fake/refs/composed_one_of_number_with_validations"
    FAKE_REFS_OBJECT_MODEL_WITH_REF_PROPS = "/fake/refs/object_model_with_ref_props"
    FAKE_REFS_ENUM = "/fake/refs/enum"
    FAKE_REFS_ARRAYOFENUMS = "/fake/refs/array-of-enums"
    FAKE_ADDITIONALPROPERTIESWITHARRAYOFENUMS = "/fake/additional-properties-with-array-of-enums"
    FAKE_JSON_FORM_DATA = "/fake/jsonFormData"
    FAKE_INLINEADDITIONAL_PROPERTIES = "/fake/inline-additionalProperties"
    FAKE_BODYWITHQUERYPARAMS = "/fake/body-with-query-params"
    ANOTHERFAKE_DUMMY = "/another-fake/dummy"
    FAKE_BODYWITHFILESCHEMA = "/fake/body-with-file-schema"
    FAKE_CASESENSITIVEPARAMS = "/fake/case-sensitive-params"
    FAKE_TESTQUERYPARAMETERS = "/fake/test-query-parameters"
    FAKE_PET_ID_UPLOAD_IMAGE_WITH_REQUIRED_FILE = "/fake/{petId}/uploadImageWithRequiredFile"
    FAKE_PARAMETER_COLLISIONS_1_A_B_AB_SELF_AB_ = "/fake/parameterCollisions/{1}/{aB}/{Ab}/{self}/{A-B}/"
    FAKE_UPLOAD_FILE = "/fake/uploadFile"
    FAKE_UPLOAD_FILES = "/fake/uploadFiles"
    FAKE_UPLOAD_DOWNLOAD_FILE = "/fake/uploadDownloadFile"
    FAKE_HEALTH = "/fake/health"
    FAKE_INLINE_COMPOSITION_ = "/fake/inlineComposition/"
    FAKE_OBJ_IN_QUERY = "/fake/objInQuery"
    FAKE_REF_OBJ_IN_QUERY = "/fake/refObjInQuery"
    FAKE_JSON_WITH_CHARSET = "/fake/jsonWithCharset"
    FAKE_RESPONSE_WITHOUT_SCHEMA = "/fake/responseWithoutSchema"
    FAKE_JSON_PATCH = "/fake/jsonPatch"
    FAKE_DELETE_COFFEE_ID = "/fake/deleteCoffee/{id}"
    FAKE_QUERY_PARAM_WITH_JSON_CONTENT_TYPE = "/fake/queryParamWithJsonContentType"
